<?php
ini_set( "display_errors", 0);

require_once 'globals.php';

##########
# This file is part of Koala.
#
# Koala is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Koala is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Koala.  If not, see <http://www.gnu.org/licenses/>.
##########

##########
# prepare the variables for the program
# currentsets - the datasets currently selected in Koala
# datasets    - all of the datasets available in Koala
# metadata    - all of the metadata for every dataset available in Koala
# box_order   - used for ordering datasets in the dropdown menu
$currentsets = array();
$datasets    = array();
$metadata    = array();
$box_order   = array();
##########

##########
# check the cookies to see if the bamboo cookie is set
# the bamboo cookie stores which datasets should be displayed by Koala
# the bamboo cookies is formatted as a comma separated list of dataset keys
if (isset($_COOKIE["bamboo"])) {
    $currentsets = split(',', $_COOKIE[ "bamboo" ]);
}
##########

##########
# obtain MySQL data
# create two dictionaries.
# datasets: houses all of the datasets for the dropdown menu
# metadata: houses all of the metadata for each dropdown menu item
$link = mysql_pconnect(DB_URL, DB_USER, DB_PW) or die ("Unable to connect to database");
mysql_select_db(DB_NAME, $link) or die("Unable to select database");

# execute the query - gather all of the dataset information from the database
$query = mysql_query("SELECT id, organism, nickname, owner, DATE_FORMAT(experimentDate, '%Y-%m-%d') AS eDate, type, phases, summary, absolute FROM koaladatasets ORDER BY organism, nickname", $link);

# loop through all of the query results
while ($row = mysql_fetch_assoc($query)) {
	# add another entry to the dropdown dictionary
	$datasets[$row['id']] = $row['organism'] . " - " . $row['nickname'] . " - " . $row['type'];
	
	# add another entry to the metadata dictionary
	$metadata[$row['id']] = "<p><b>Date:</b> " . $row['eDate'] . "<br />"
		. "<b>Experimentor:</b> " . $row['owner'] . "<br />"
		. "<b>Phases:</b> " . $row['phases'] . "<br />"
		. "<b>Metadata:</b> " . $row['summary'] . "</p>";
	
	# handle the absolute scale
	$absolute[$row['id']] = ($row['absolute'] ? "true" : "false");
	
	# add the current id to the box_order list
	# the box_order list is used to maintain the order
	# of the MySQL query (organism, experiment) when 
	# writing the dropdown menu to HTML
	$box_order[] = $row['id'];
}
?>
<html>
	<head>
		<title>Koala configuration</title>
		<script language="javascript" type="text/javascript">
		var datatags = {<?php
##########
# writes all of the datasets to a javascript list
$first_print = true;
foreach ($datasets as $key => $data) {
	if (!$first_print) {
		echo(",");
	}
	echo("'" . $key . "' : '" . str_replace(array("'", "\r\n", "\r", "\n"), array("\\'", "<br />", "<br />", "<br />"), $data) . "'");
	$first_print = false;
}
##########
?>};
		var metadatalist = {<?php
##########
# writes the metadata to a javascript hashtable
$first_print = true;
foreach ($metadata as $key => $data) {
	if (!$first_print) {
		echo(",");
	}
	echo("'" . $key . "' : '" . str_replace(array("'", "\r\n", "\r", "\n"), array("\\'", "<br />", "<br />", "<br />"), $data) . "'");
	$first_print = false;
}
##########
?>};
		var scales = {<?php
##########
# writes the metadata to a javascript hashtable
$first_print = true;
foreach ($absolute as $key => $data) {
	if (!$first_print) {
		echo(",");
	}
	echo("'$key' : $data");
	$first_print = false;
}
##########
?>};
		/**
		 * gets a cookie
		 * source: http://www.w3schools.com/js/js_cookies.asp
		 */
		function get_cookie(name) {
		    var ca = document.cookie.split(';');
		    var nameEQ = name + "=";
		    for(var i=0;i < ca.length;i++) {
		        var c = ca[i];
		        while (c.charAt(0)==' ') c = c.substring(1,c.length);
		        if (c.indexOf(nameEQ) == 0) return decodeURIComponent(c.substring(nameEQ.length,c.length));
		    }
    		    return null;
		}
		/**
		 * Sets a cookie
		 * source: http://www.w3schools.com/js/js_cookies.asp
		 */
		function setCookie(c_name, value, exdays) {
			var exdate  = new Date();
			exdate.setDate(exdate.getDate() + exdays);
			var c_value = escape(value) + ((exdays==null) ? "" : "; expires="+exdate.toUTCString());
			document.cookie=c_name + "=" + c_value + "; path=/";
		}

		/**
		 * Adds the dataset currently selected in the dropdown box
		 * to the list of datasets to overlay.
		 */
		function add() {
			var sbox   = document.getElementById("dataset_selector");
			var bamboo = get_cookie("bamboo");
			var scale  = get_cookie("scale");
			var key    = sbox.options[sbox.selectedIndex].value;

			if ((scale && scale != "") || !bamboo) {
				if (scales[key]) {
					setCookie("scale", "true", 2);
				} else {
					setCookie("scale", "", 2);
				}
			}
			
			if (key) {
				if (bamboo) {
					bamboo = bamboo + "," + key;
				} else {
					bamboo = key;
				}
				setCookie("bamboo", bamboo, 2);
				sbox.remove(sbox.selectedIndex);
				update();
			}
		}
		
		function arrayfind(key, array) {
			for(var count=0, len=array.length;count < len;count++){
				if(array[count].value == key) {
					return count;
				}
			}
			return -1;
		}

		/**
		 * adds an option back to the selection box
		 */
		function re_add_option(key) {
			var sbox      = document.getElementById("dataset_selector");
			
			if (!arrayfind(key, sbox.options)) {
				var option = document.createElement("option");
				option.value = key;
				option.text = datatags[key];
				sbox.add(selectBoxOption, null);
			}
		}

		/**
		 * handles removing a dataset from the list of datasets which the
		 * user wants to work with
		 */
		function deleteDataset(key) {
			var bambootmp = get_cookie("bamboo").split(",");
			var bambooout = new Array();
			var scale     = true;

			
			for(var count=0, len=bambootmp.length; count < len; count++){
				if (bambootmp[count] != key) {
					bambooout.push(bambootmp[count]);
					scale = scale && scales[bambootmp[count]];
				}
			}
			
			if (scale) {
				setCookie("scale", "true", 2);
			} else {
				setCookie("scale", "", 2);
			}
			setCookie("bamboo", bambooout.join(","), 2);

			/* add the option back to the selection box */
			re_add_option(key);
			update();
		}

		/**
		 * updates the metadata box in Koala, whenever a different dataset
		 * is selected in the dropdown box
		 */
		function changeindex (index) {
			if (metadatalist[index]) {
				document.getElementById("metadatadiv").innerHTML = metadatalist[index];
			}
		}

		/**
		 * reloads both the current and parent pages
		 */
		function update () {
			var sbox = document.getElementById("dataset_selector");
			
			try {
				window.opener.location.reload(false);
			} catch (ex) {
			}
			location.reload(false);
		}

		/**
		 * updates the metadata box in Koala when the page is first loaded
		 */
		function load_data () {
			var sbox = document.getElementById("dataset_selector");
			changeindex(sbox.options[sbox.selectedIndex].value);
		}
		</script>
	</head>

	<body onload='load_data()'>
		<table>
			<tr valign="top">
				<td>
					<img src="koala.gif" align="left" />
				</td>
				<td>
					<h1>Koala <small><small><small><a href="help.html" target="_blank">HELP!</a>&nbsp;<a href="edit.php" target="_blank">ADMIN</a></small></small></small></h1>
					<p>
						<form onsubmit="return false;">
							Add experiments:
							<select id="dataset_selector" name="dataset" onchange="changeindex(this.options[this.selectedIndex].value)">
<?php
foreach ($box_order as $key) {
	if (empty($currentsets) || ! in_array($key, $currentsets)) { ?>
						        	<option value="<?php echo($key); ?>"><?php echo($datasets[$key]); ?></option>
<?php } } ?>
							</select>
							<input type="submit" value="Add" onclick="add()" /><br />
							<div id="metadatadiv"></div>
						</form>
					</p>
<?php
##########
# write any datasets that the user is currently using
# this is so the user can remove datasets from their current workspace
if (!empty($currentsets)) { ?>
					<hr /><form onsubmit="return false;">
<?php
	foreach ($currentsets as $key) {
		if (!empty($datasets[$key])) {
?>					<dl><dt><input type="submit" value="-" onclick="deleteDataset(<?php echo($key); ?>)" /><big><b><?php echo($datasets[$key]); ?></b></big></dt>
<?php
			if (!empty($metadata[$key])) {
				echo("<dd>" . $metadata[$key] . "</dd>");
			} else {
				echo("<dd><i>No summary available!</i></dd>");
			}
			echo("</dl>");
		}
	}
	echo("</form>");
}
##########

?>
				</td>
			</tr>
		</table>
	</body>
</html>

