<?php
ini_set( "display_errors", 0);

require_once 'globals.php';

##########
# This file is part of Koala.
#
# Koala is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Koala is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Koala.  If not, see <http://www.gnu.org/licenses/>.
##########

# ensure that the HTTP response uses the proper MIME type
header('Content-Type: text/plain');

# prepare the results array
$results = array();	# a hash dictionary used to store the results for output

# security by obscurity - "cooked bamboo" instead of raw data! ;)
# the cooked parameter indicates that all of the expression data
# should be normalized to whatever scale is indicated by the constant 'SCALE'
$normalize	= !empty($_GET['cooked']);	# boolean to store whether data in Koala should be normalized
$normrng		= array();					# a variable used for normalization - this variable stores the minimum and maximum for each dataset
$SCALE		= 10000;					# the scale to use for normalizing date (if the request URI contains the 'cooked' parameter)

# ensure that the bamboo parameter is set
if (!empty($_GET['bamboo'])) {
	$datasets = split(',', $_GET['bamboo']);

	# connect to the database
	$link = mysql_pconnect(DB_URL, DB_USER, DB_PW) or die ("Unable to connect to database");
	mysql_select_db(DB_NAME, $link) or die("Unable to select database");

	# iterate through all of the data in the dataset
	foreach ($datasets as $dset) {
		$cmin = 10000000;	# current dataset's minimum value (used for normalization)
		$cmax = -10000000;	# current dataset's maximum value (used for normalization)

		# determine if the dataset is to be represented in log mode (log 2 scale)
		$query = mysql_query("SELECT logmode FROM koaladatasets WHERE id = '" . ((int)$dset) . "'", $link);
		$rowtemp = mysql_fetch_assoc($query);
		$logmode = (!empty($rowtemp) && $rowtemp['logmode'] > 0);

		# obtain all of the data from the dataset
		$query = mysql_query("SELECT * FROM koaladata WHERE dataset = " . ((int)$dset) . " ORDER BY dataset", $link);

		# iterate through the locus tags in the dataset
		while ($row = mysql_fetch_assoc($query)) {
			# store the two variables of interest within the dataset in easy to access local variables
			$tag = $row['tag'];
			$exp = $row['value'];

			# if the dataset is to be represented as log mode, then perform a log 2 conversion
			if ($logmode) {
				$exp = log($exp + 10.) / log(2.);
			}

			# ensure that the 
			if (empty($results[$tag])) {
				$results[$tag] = array();
			}

			# find the minimums and maximums for each dataset (in case we wish to normalize the data)
			$cmin = min($exp, $cmin);
			$cmax = max($exp, $cmax);

			# store the current expression value
			$results[$tag][$dset] = $exp;
		}
		# store the minimum and maximum for the current dataset
		$normrng[$dset] = array('min' => $cmin, 'max' => $cmax);
	}

	# print the results as a CSV
	foreach ($results as $tag => $row) {
		echo($tag);
		foreach ($datasets as $dset) {
			echo("\t");

			# if there is expression data for the current column (dataset), then print it
			if (isset($row[$dset])) {
				$exp = $results[$tag][$dset];

				# normalize the data if the user desires
				if ($normalize && !empty($normrng[$dset])) {
					$cmin = $normrng[$dset]['min'];
					$cmax = $normrng[$dset]['max'];
					$exp = ($SCALE * ($exp - $cmin) / ($cmax - $cmin) - $SCALE / 2);
				}
				
				# print the current column's expression value
				echo($exp);
			}
		}
		echo("\n");
	}
}
?>
